/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoNLpackGeneratorDiffResultDetail]のクラス
 */
package blanco.nlpack.generator.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.nlpack.generator.task.valueobject.BlancoNLpackGeneratorDiffResultDetailProcessInput;

/**
 * Apache Antタスク [BlancoNLpackGeneratorDiffResultDetail]のクラス。
 *
 * 翻訳結果ログ(ResultDetailファイル)の差分を取得します。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.nlpack.generator.task]にBlancoNLpackGeneratorDiffResultDetailBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blanconlpackgeneratordiffresultdetail&quot; classname=&quot;blanco.nlpack.generator.task.BlancoNLpackGeneratorDiffResultDetailTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoNLpackGeneratorDiffResultDetailTask extends Task {
    /**
     * 翻訳結果ログ(ResultDetailファイル)の差分を取得します。
     */
    protected BlancoNLpackGeneratorDiffResultDetailProcessInput fInput = new BlancoNLpackGeneratorDiffResultDetailProcessInput();

    /**
     * フィールド [sourceleft] に値がセットされたかどうか。
     */
    protected boolean fIsFieldSourceleftProcessed = false;

    /**
     * フィールド [sourceright] に値がセットされたかどうか。
     */
    protected boolean fIsFieldSourcerightProcessed = false;

    /**
     * フィールド [targetdiff] に値がセットされたかどうか。
     */
    protected boolean fIsFieldTargetdiffProcessed = false;

    /**
     * フィールド [reportequal] に値がセットされたかどうか。
     */
    protected boolean fIsFieldReportequalProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[sourceleft]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力の翻訳結果ログ(左辺)。<br>
     *
     * @param arg セットしたい値
     */
    public void setSourceleft(final String arg) {
        fInput.setSourceleft(arg);
        fIsFieldSourceleftProcessed = true;
    }

    /**
     * Antタスクの[sourceleft]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力の翻訳結果ログ(左辺)。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getSourceleft() {
        return fInput.getSourceleft();
    }

    /**
     * Antタスクの[sourceright]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 入力の翻訳結果ログ(右辺)。<br>
     *
     * @param arg セットしたい値
     */
    public void setSourceright(final String arg) {
        fInput.setSourceright(arg);
        fIsFieldSourcerightProcessed = true;
    }

    /**
     * Antタスクの[sourceright]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 入力の翻訳結果ログ(右辺)。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getSourceright() {
        return fInput.getSourceright();
    }

    /**
     * Antタスクの[targetdiff]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * 出力の翻訳結果ログ差分ファイル。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetdiff(final String arg) {
        fInput.setTargetdiff(arg);
        fIsFieldTargetdiffProcessed = true;
    }

    /**
     * Antタスクの[targetdiff]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * 出力の翻訳結果ログ差分ファイル。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetdiff() {
        return fInput.getTargetdiff();
    }

    /**
     * Antタスクの[reportequal]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     * 一致する行を報告するかどうか。通常は これは不要だと考えています。<br>
     *
     * @param arg セットしたい値
     */
    public void setReportequal(final boolean arg) {
        fInput.setReportequal(arg);
        fIsFieldReportequalProcessed = true;
    }

    /**
     * Antタスクの[reportequal]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * 一致する行を報告するかどうか。通常は これは不要だと考えています。<br>
     * デフォルト値[false]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getReportequal() {
        return fInput.getReportequal();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    @Override
    public final void execute() throws BuildException {
        System.out.println("BlancoNLpackGeneratorDiffResultDetailTask begin.");

        // 項目番号[1]、アトリビュート[sourceleft]は必須入力です。入力チェックを行います。
        if (fIsFieldSourceleftProcessed == false) {
            throw new BuildException("必須アトリビュート[sourceleft]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[sourceright]は必須入力です。入力チェックを行います。
        if (fIsFieldSourcerightProcessed == false) {
            throw new BuildException("必須アトリビュート[sourceright]が設定されていません。処理を中断します。");
        }
        // 項目番号[3]、アトリビュート[targetdiff]は必須入力です。入力チェックを行います。
        if (fIsFieldTargetdiffProcessed == false) {
            throw new BuildException("必須アトリビュート[targetdiff]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- sourceleft:[" + getSourceleft() + "]");
            System.out.println("- sourceright:[" + getSourceright() + "]");
            System.out.println("- targetdiff:[" + getTargetdiff() + "]");
            System.out.println("- reportequal:[" + getReportequal() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoNLpackGeneratorDiffResultDetailProcessインタフェースを実装して blanco.nlpack.generator.taskパッケージに BlancoNLpackGeneratorDiffResultDetailProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoNLpackGeneratorDiffResultDetailProcess proc = new BlancoNLpackGeneratorDiffResultDetailProcessImpl();
            if (proc.execute(fInput) != BlancoNLpackGeneratorDiffResultDetailBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
